$ set def isode:[compat]
$ if p1 .EQS. "CLEAN" then goto clean
$ if p1 .EQS. "TIDY"  then goto tidy
$ debug == ""
$ if p1 .EQS. "DEBUG" then debug == p1
$ if f$trnlnm("isode_options") .NES. ""
$  then
$   options == "/define=(" + f$trnlnm("isode_options") + ")"
$  else
$   options == ""
$ endif
$ map = ""
$ altered == 0
$ @isode:[utils]cc externs
$ @isode:[utils]cc asprintf
$ @isode:[utils]cc camtec
$ @isode:[utils]cc explode
$ @isode:[utils]cc general
$ @isode:[utils]cc implode
$ @isode:[utils]cc internet
$ @isode:[utils]cc isoaddrs
$ @isode:[utils]cc isofiles
$ @isode:[utils]cc isohost
$ @isode:[utils]cc isoservent
$ @isode:[utils]cc logger
$ @isode:[utils]cc na2norm
$ @isode:[utils]cc na2str
$ @isode:[utils]cc sel2str
$ @isode:[utils]cc select
$ @isode:[utils]cc serror
$ @isode:[utils]cc servbyname
$ @isode:[utils]cc servbyport
$ @isode:[utils]cc servbysel
$ @isode:[utils]cc signals
$ @isode:[utils]cc sprintb
$ @isode:[utils]cc str2elem
$ @isode:[utils]cc str2sel
$ @isode:[utils]cc str2taddr
$ @isode:[utils]cc str2vec
$ @isode:[utils]cc sunlink
$ @isode:[utils]cc taddr2str
$ @isode:[utils]cc tailor
$ @isode:[utils]cc ubcx25
$ @isode:[utils]cc ultrix25
$ @isode:[utils]cc hpuxx25
$ @isode:[utils]cc dgram
$ @isode:[utils]cc x25addr
$ @isode:[utils]cc saddr2str
$ @isode:[utils]cc str2saddr
$ @isode:[utils]cc baduser
$ @isode:[utils]cc getpassword
$ @isode:[utils]cc chrcnv
$ @isode:[utils]cc cmd_srch
$ @isode:[utils]cc lexequ
$ @isode:[utils]cc lexnequ
$ @isode:[utils]cc log_tai
$ @isode:[utils]cc nochrcnv
$ @isode:[utils]cc rcmd_srch
$ @isode:[utils]cc smalloc
$ @isode:[utils]cc sstr2arg
$ @isode:[utils]cc strdup
$ @isode:[utils]cc pa2str
$ @isode:[utils]cc putenv
$ @isode:[utils]cc chkpassword
$ @isode:[utils]cc norm2na
$ @isode:[utils]cc pl_tables
$ @isode:[utils]cc pepsy_str
$ @isode:[utils]cc bcd2char
$ @isode:[utils]cc ccurx25
$ @isode:[utils]cc char2bcd
$ @isode:[utils]cc internet_tli
$ @isode:[utils]cc isonsapsnpa
$ @isode:[utils]cc nsapcmp
$ if f$search("compat_xfr.mar") .NES. "" then goto m0
$ write sys$output "Creating compat_xfr.mar - IGNORE any link errors!"
$ macro compat_xfr.dummy
$ delete collectopt.opt;
$ copy isode:[utils]collectopt.dummy collectopt.opt
$ if f$search("compatlib.exe") .NES. "" then $ delete compatlib.exe;*
$ map = "/map=compat.map/full"
$ set noon
$ gosub link
$ set on
$! map = "/nomap"
$ map_extract compat
$! delete compat.map;*
$ delete compat_xfr.obj;*
$ m0:
$ @isode:[utils]mar compat_xfr
$ if f$search("compatlib.exe") .EQS. "" then goto m2
$ if altered .NE. 0 then goto m1
$ write sys$output "compatlib is up-to-date"
$ exit
$ m1:
$ delete compatlib.exe;
$ m2:
$ write sys$output "Linking compatlib"
$ dbg == ""
$ if debug .EQS. "DEBUG" then dbg = "/debug"
$ gosub link
$ exit
$ link:
$ link 'map' 'dbg'/share=compatlib.exe -
	externs, -
	asprintf,camtec,explode, -
	general,implode,internet,isoaddrs,isofiles,isohost,isoservent, -
	logger,na2norm,na2str,sel2str,select,serror,servbyname, -
	servbyport,servbysel,signals,sprintb,str2elem,str2sel, -
	str2taddr,str2vec,sunlink,taddr2str,tailor,ubcx25,ultrix25,hpuxx25, -
        dgram,x25addr,saddr2str,str2saddr,chkpassword,norm2na, -
	baduser,getpassword,chrcnv,cmd_srch,lexequ,lexnequ,log_tai, -
	nochrcnv,rcmd_srch,smalloc,sstr2arg,strdup,pa2str,putenv, -
	pl_tables,pepsy_str,bcd2char,ccurx25,char2bcd,internet_tli, -
	isonsapsnpa,nsapcmp, -
        [utils]psectopt/opt, -
        []collectopt/opt, -
	[]opt/opt
$ return
$ tidy:
$ @isode:[utils]tidy
$ exit
$ clean:
$ @isode:[utils]clean
$ exit

