$ set def isode:[ftam]
$ if p1 .EQS. "CLEAN" then goto clean
$ if p1 .EQS. "TIDY"  then goto tidy
$ debug == ""
$ if p1 .EQS. "DEBUG" then debug == p1
$ if f$trnlnm("isode_options") .NES. ""
$  then
$   options == "/define=(" + f$trnlnm("isode_options") + ",PEPYPATH)"
$  else
$   options == "/define=(PEPYPATH)"
$ endif
$ map = "/nomap"
$ altered == 0
$ if f$search("isode_orig:[]ftam_tables.c") .NES. "" then goto m1
$ set def isode_orig:[]
$ pepsy "-A" -f -h -m cont.py
$ pepsy "-A" -f -h -m fadu.py
$ pepsy "-A" -f -h -m ftam.py
$ set def isode:[]
$ m1:
$ @isode:[utils]h cont-types
$ @isode:[utils]h fadu-types
$ @isode:[utils]h ftam-types
$ copy cont-types.h isode:[h]cont-types.h
$ copy fadu-types.h isode:[h]fadu-types.h
$ copy ftam-types.h isode:[h]ftam-types.h
$ pu isode:[h]
$ @isode:[utils]cc cont_tables
$ @isode:[utils]cc fadu_tables
$ @isode:[utils]cc ftam_tables
$ @isode:[utils]cc ftamabort
$ @isode:[utils]cc ftamaccess1
$ @isode:[utils]cc ftamaccess2
$ @isode:[utils]cc ftamacl
$ @isode:[utils]cc ftamattr
$ @isode:[utils]cc ftambits
$ @isode:[utils]cc ftambulk
$ @isode:[utils]cc ftambulk1
$ @isode:[utils]cc ftambulk2
$ @isode:[utils]cc ftamchrg
$ @isode:[utils]cc ftamconctl
$ @isode:[utils]cc ftamdiag
$ @isode:[utils]cc ftamdocument
$ @isode:[utils]cc ftamerror
$ @isode:[utils]cc ftamfaduid
$ @isode:[utils]cc ftamfdf
$ @isode:[utils]cc ftamgroup1
$ @isode:[utils]cc ftamgroup2
$ @isode:[utils]cc ftaminitiate
$ @isode:[utils]cc ftamlose
$ @isode:[utils]cc ftampass
$ @isode:[utils]cc ftamprovider
$ @isode:[utils]cc ftamrelease1
$ @isode:[utils]cc ftamrelease2
$ @isode:[utils]cc ftamrespond
$ @isode:[utils]cc ftamselect
$ @isode:[utils]cc ftamshare
$ @isode:[utils]cc ftamtrace
$ if f$search("ftam_xfr.mar") .NES. "" then goto m0
$ write sys$output "Creating ftam_xfr.mar - IGNORE any link errors!"
$ macro ftam_xfr.dummy
$ delete collectopt.opt;
$ copy isode:[utils]collectopt.dummy collectopt.opt
$ if f$search("ftamlib.exe") .NES. "" then $ delete ftamlib.exe;*
$ map = "/map=ftam.map/full"
$ set noon
$ gosub link
$ set on
$ map = "/nomap"
$ map_extract ftam
$ delete ftam.map;*
$ delete ftam_xfr.obj;*
$ m0:
$ @isode:[utils]mar ftam_xfr
$ if f$search("ftamlib.exe") .EQS. "" then goto m4
$ if altered .NE. 0 then goto m3
$ write sys$output "ftamlib is up-to-date"
$ exit
$ m3:
$ delete ftamlib.exe;
$ m4:
$ write sys$output "Linking ftamlib"
$ dbg == ""
$ if debug .EQS. "DEBUG" then dbg = "/debug"
$ gosub link
$ exit
$ link:
$ link 'map' 'dbg'/share=ftamlib.exe -
	cont_tables,fadu_tables,ftam_tables, -
	ftamabort,ftamaccess1,ftamaccess2,ftamacl,ftamattr,ftambits, -
	ftambulk,ftambulk1,ftambulk2,ftamchrg,ftamconctl,ftamdiag,ftamdocument, -
	ftamerror,ftamfaduid,ftamfdf,ftamgroup1,ftamgroup2,ftaminitiate,ftamlose, -
	ftampass,ftamprovider,ftamrelease1,ftamrelease2,ftamrespond,ftamselect, -
	ftamshare,ftamtrace, -
        [utils]psectopt/opt, -
        []collectopt/opt, -
	[]opt/opt
$ return
$ tidy:
$ @isode:[utils]tidy
$ delete isode_orig:[]*_tables.*;*,*-types.h;*
$ exit
$ clean:
$ @isode:[utils]clean
$ delete isode_orig:[]*_tables.*;*,*-types.h;*,*.ph;*
$ exit

