$ set def isode:[psap]
$ if p1 .EQS. "CLEAN" then goto clean
$ if p1 .EQS. "TIDY"  then goto tidy
$ debug == ""
$ if p1 .EQS. "DEBUG" then debug == p1
$ if f$trnlnm("isode_options") .NES. ""
$  then
$   options == "/define=(" + f$trnlnm("isode_options") + ")"
$  else
$   options == ""
$ endif
$ map = "/nomap"
$ altered == 0
$ @isode:[utils]cc addr2ref
$ @isode:[utils]cc bit2prim
$ @isode:[utils]cc bitstr2strb
$ @isode:[utils]cc bit_ops
$ @isode:[utils]cc dg2ps
$ @isode:[utils]cc fdx2ps
$ @isode:[utils]cc flag2prim
$ @isode:[utils]cc gtime
$ @isode:[utils]cc int2strb
$ @isode:[utils]cc isobject
$ @isode:[utils]cc num2prim
$ @isode:[utils]cc obj2prim
$ @isode:[utils]cc objectbyname
$ @isode:[utils]cc objectbyoid
$ @isode:[utils]cc ode2oid
$ @isode:[utils]cc oid2ode
$ @isode:[utils]cc oid_cmp
$ @isode:[utils]cc oid_cpy
$ @isode:[utils]cc oid_free
$ @isode:[utils]cc pe2pl
$ @isode:[utils]cc pe2ps
$ @isode:[utils]cc pe2ssdu
$ @isode:[utils]cc pe2text
$ @isode:[utils]cc pe2uvec
$ @isode:[utils]cc pe_alloc
$ @isode:[utils]cc pe_cmp
$ @isode:[utils]cc pe_cpy
$ @isode:[utils]cc pe_error
$ @isode:[utils]cc pe_expunge
$ @isode:[utils]cc pe_extract
$ @isode:[utils]cc pe_free
$ @isode:[utils]cc pe_pullup
$ @isode:[utils]cc pl2pe
$! @isode:[utils]cc pl_tables - now in compatlib
$ @isode:[utils]cc prim2bit
$ @isode:[utils]cc prim2flag
$ @isode:[utils]cc prim2num
$ @isode:[utils]cc prim2oid
$ @isode:[utils]cc prim2qb
$ @isode:[utils]cc prim2real
$ @isode:[utils]cc prim2set
$ @isode:[utils]cc prim2str
$ @isode:[utils]cc prim2time
$ @isode:[utils]cc ps2pe
$ @isode:[utils]cc ps_alloc
$ @isode:[utils]cc ps_error
$ @isode:[utils]cc ps_flush
$ @isode:[utils]cc ps_free
$ @isode:[utils]cc ps_get_abs
$ @isode:[utils]cc ps_io
$ @isode:[utils]cc ps_prime
$ @isode:[utils]cc qb2pe
$ @isode:[utils]cc qb2prim
$ @isode:[utils]cc qb2str
$ @isode:[utils]cc qbuf2pe
$ @isode:[utils]cc qbuf2ps
$ @isode:[utils]cc qb_free
$ @isode:[utils]cc qb_pullup
$ @isode:[utils]cc seq_add
$ @isode:[utils]cc seq_addon
$ @isode:[utils]cc seq_del
$ @isode:[utils]cc seq_find
$ @isode:[utils]cc set_add
$ @isode:[utils]cc set_addon
$ @isode:[utils]cc set_del
$ @isode:[utils]cc set_find
$ @isode:[utils]cc sprintoid
$ @isode:[utils]cc sprintref
$ @isode:[utils]cc ssdu2pe
$ @isode:[utils]cc std2ps
$ @isode:[utils]cc str2oid
$ @isode:[utils]cc str2pe
$ @isode:[utils]cc str2prim
$ @isode:[utils]cc str2ps
$ @isode:[utils]cc str2qb
$ @isode:[utils]cc strb2bitstr
$ @isode:[utils]cc strb2int
$ @isode:[utils]cc time2prim
$ @isode:[utils]cc time2str
$ @isode:[utils]cc tm2ut
$ @isode:[utils]cc ts2ps
$ @isode:[utils]cc ut2tm
$ @isode:[utils]cc uvec2ps
$ @isode:[utils]cc pe2qb_f
$ @isode:[utils]cc qbuf2pe_f
$ if f$search("psap_xfr.mar") .NES. "" then goto m0
$ write sys$output "Creating psap_xfr.mar - IGNORE any link errors!"
$ macro psap_xfr.dummy
$ delete collectopt.opt;
$ copy isode:[utils]collectopt.dummy collectopt.opt
$ if f$search("psaplib.exe") .NES. "" then $ delete psaplib.exe;*
$ map = "/map=psap.map/full"
$ set noon
$ gosub link
$ set on
$ map = "/nomap"
$ map_extract psap
$ delete psap.map;*
$ delete psap_xfr.obj;*
$ m0:
$ @isode:[utils]mar psap_xfr
$ if f$search("psaplib.exe") .EQS. "" then goto m2
$ if altered .NE. 0 then goto m1
$ write sys$output "psaplib is up-to-date"
$ exit
$ m1:
$ delete psaplib.exe;
$ m2:
$ write sys$output "Linking psaplib"
$ dbg == ""
$ if debug .EQS. "DEBUG" then dbg = "/debug"
$ gosub link
$ exit
$ link:
$ link 'map' 'dbg'/share=psaplib.exe -
	addr2ref,bit2prim,bitstr2strb,bit_ops,dg2ps,fdx2ps,flag2prim, -
	gtime,int2strb,isobject,num2prim,obj2prim,objectbyname, -
	objectbyoid,ode2oid,oid2ode,oid_cmp,oid_cpy,oid_free,pe2pl,pe2ps, -
	pe2ssdu,pe2text,pe2uvec,pe_alloc,pe_cmp,pe_cpy,pe_error,pe_expunge, -
	pe_extract,pe_free,pe_pullup,pl2pe,prim2bit,prim2flag, -
	prim2num,prim2oid,prim2qb,prim2real,prim2set,prim2str,prim2time,ps2pe, -
	ps_alloc,ps_error,ps_flush,ps_free,ps_get_abs,ps_io,ps_prime, -
	qb2pe,qb2prim,qb2str,qbuf2pe,qbuf2ps,qb_free,qb_pullup,seq_add, -
	seq_addon,seq_del,seq_find,set_add,set_addon,set_del,set_find,sprintoid, -
	sprintref,ssdu2pe,std2ps,str2oid,str2pe,str2prim,str2ps,str2qb, -
	strb2bitstr,strb2int,time2prim,time2str,tm2ut,ts2ps,ut2tm,uvec2ps, -
	pe2qb_f,qbuf2pe_f, -
        [utils]psectopt/opt, -
        []collectopt/opt, -
	[]opt/opt
$ return
$ tidy:
$ @isode:[utils]tidy
$ exit
$ clean:
$ @isode:[utils]clean
$ exit

