$ set def isode:[rosy]
$ if p1 .EQS. "CLEAN" then goto clean
$ if p1 .EQS. "TIDY"  then goto tidy
$ debug == ""
$ if p1 .EQS. "DEBUG" then debug == p1
$ if f$trnlnm("isode_options") .NES. ""
$  then
$   options == "/define=(" + f$trnlnm("isode_options") + ",PEPYPATH)"
$  else
$   options == "/define=(PEPYPATH)"
$ endif
$ map = "/nomap"
$ altered == 0
$ @isode:[utils]copy lex.c lex.c
$!
$ @isode:[utils]h rosy-defs
$ @isode:[utils]cc rosy
$ @isode:[utils]cc yacc
$ if f$search("rosy.exe") .EQS. "" then goto m4
$ if altered .EQ. 0 then goto m6
$ delete rosy.exe;
$ m4:
$ write sys$output "Linking rosy"
$ link rosy,yacc,[pepy]pepy_misc, -
         [utils]psectopt/opt,[]rosyopt/opt
$!
$ m6:
$ altered == 0
$ @isode:[utils]cc rydispatch
$ @isode:[utils]cc rydsblock
$ @isode:[utils]cc rydserror
$ @isode:[utils]cc rydsresult
$ @isode:[utils]cc rydsurej
$ @isode:[utils]cc ryfind
$ @isode:[utils]cc rygenid
$ @isode:[utils]cc rylose
$ @isode:[utils]cc ryopblock
$ @isode:[utils]cc ryoper
$ @isode:[utils]cc ryopinvoke
$ @isode:[utils]cc rystub
$ @isode:[utils]cc rywait
$ @isode:[utils]copy rydispatch.c p-rydispatch.c_new
$ @isode:[utils]copy rydsblock.c p-rydsblock.c_new
$ @isode:[utils]copy rydserror.c p-rydserror.c_new
$ @isode:[utils]copy rydsresult.c p-rydsresult.c_new
$ @isode:[utils]copy rydsurej.c p-rydsurej.c_new
$ @isode:[utils]copy ryfind.c p-ryfind.c_new
$ @isode:[utils]copy rygenid.c p-rygenid.c_new
$ @isode:[utils]copy rylose.c p-rylose.c_new
$ @isode:[utils]copy ryopblock.c p-ryopblock.c_new
$ @isode:[utils]copy ryoper.c p-ryoper.c_new
$ @isode:[utils]copy ryopinvoke.c p-ryopinvoke.c_new
$ @isode:[utils]copy rystub.c p-rystub.c_new
$ @isode:[utils]copy rywait.c p-rywait.c_new
$ if f$trnlnm("isode_options") .NES. ""
$  then
$   options == "/define=(" + f$trnlnm("isode_options") + ",PEPYPATH,PEPSY_VERSION=2)"
$  else
$   options == "/define=(PEPYPATH,PEPSY_VERSION=2)"
$ endif
$ @isode:[utils]cc p-rydispatch
$ @isode:[utils]cc p-rydsblock
$ @isode:[utils]cc p-rydserror
$ @isode:[utils]cc p-rydsresult
$ @isode:[utils]cc p-rydsurej
$ @isode:[utils]cc p-ryfind
$ @isode:[utils]cc p-rygenid
$ @isode:[utils]cc p-rylose
$ @isode:[utils]cc p-ryopblock
$ @isode:[utils]cc p-ryoper
$ @isode:[utils]cc p-ryopinvoke
$ @isode:[utils]cc p-rystub
$ @isode:[utils]cc p-rywait
$ if f$search("rosy_xfr.mar") .NES. "" then goto m0
$ write sys$output "Creating rosy_xfr.mar - IGNORE any link errors!"
$ macro rosy_xfr.dummy
$ delete collectopt.opt;
$ copy isode:[utils]collectopt.dummy collectopt.opt
$ if f$search("rosylib.exe") .NES. "" then $ delete rosylib.exe;*
$ map = "/map=rosy.map/full"
$ set noon
$ gosub link
$ set on
$ map = "/nomap"
$ map_extract rosy
$ delete rosy.map;*
$ delete rosy_xfr.obj;*
$ m0:
$ @isode:[utils]mar rosy_xfr
$ if f$search("rosylib.exe") .EQS. "" then goto m9
$ if altered .NE. 0 then goto m8
$ write sys$output "rosylib is up-to-date"
$ goto m10
$ m8:
$ delete rosylib.exe;
$ m9:
$ write sys$output "Linking rosylib"
$ dbg == ""
$ if debug .EQS. "DEBUG" then dbg = "/debug"
$ gosub link
$ m10:
$ copy rosy.exe bin:[000000]rosy.exe
$ pu bin:[000000]rosy.exe
$ exit
$ link:
$ link 'map' 'dbg'/share=rosylib.exe -
	rydispatch,rydsblock,rydserror,rydsresult,rydsurej, -
	ryfind,rygenid,rylose,ryopblock,ryoper,ryopinvoke,rystub,rywait, -
	p-rydispatch,p-rydsblock,p-rydserror,p-rydsresult,p-rydsurej, -
	p-ryfind,p-rygenid,p-rylose,p-ryopblock,p-ryoper,p-ryopinvoke, -
	p-rystub,p-rywait, -
	[utils]psectopt/opt, -
        []collectopt/opt, -
	[]opt/opt
$ return
$ tidy:
$ @isode:[utils]tidy
$ delete p-*.*;
$ exit
$ clean:
$ @isode:[utils]clean
$ delete p-*.*;
$ exit

