#include <stdio.h>
#include <errno.h>
#define TRUE 1
#define FALSE 0
#define BUFFER 256

int x_count;
int changed;
char * malloc();
char eol[2] = "\n";

main(argc, argv)
int argc;
char *argv[];
{
  int in_identifier, in_comment, in_quotes, in_preprocessor;
  int c, prev_c, count, length, i;
  char id[1024], s[BUFFER], buffer[BUFFER], *p, *q, *r, *strchr(), newbuff[BUFFER];
  FILE *fopen(), *infile, *outfile;

  if (argc < 2) {
     printf("Usage: Copy-wrap infile outfile\n");
     exit();
  }

  if ( (infile = fopen(argv[1],"r")) == NULL) {
     printf("%s does not exist\n",argv[1]);
     exit();
  }
  if ( (outfile = fopen(argv[2],"w")) == NULL) {
     printf("Cannot open output file errno=%d\n",errno);
     exit();
  }
  changed = 0;
  prev_c = '\n';
  length = 1;
  in_identifier = FALSE;
  in_comment = FALSE;
  in_quotes = FALSE;
  in_preprocessor = FALSE;
  p = buffer;
  memset(buffer,0,BUFFER);
  c = getc(infile);
  while (c != EOF) {
     length = (int)(p-buffer);
     if (prev_c == '\n') in_preprocessor = (c == '#');
     if ( (length > 160) && ( ! in_preprocessor) &&( ! in_quotes) &&
      (strchr("; \t)(",prev_c) != NULL)) {
        fputs(buffer,outfile);
        fputs(eol,outfile);
        memset(buffer,0,BUFFER);
	p = buffer;
     }
     if ((length > 160) && (c == '\\')) {
        *p++ = '\\';
        fputs(buffer,outfile);
        fputs(eol,outfile);
        memset(buffer,0,BUFFER);
	p = buffer;
     }
     if (in_quotes) {
        if (c == '"') in_quotes = FALSE;
        *p++ = c;
     }
     else if (in_comment) {
        if ((c == '/') && (prev_c == '*')) in_comment = FALSE;
        *p++ = c;
     }
     else if ( ! in_identifier) {
        if ( ((c >= 'A') && (c <= 'Z')) || ((c >= 'a') && (c <= 'z'))
             || (c == '_') ) {
           in_identifier = TRUE;
           count = 0;
           id[count] = c;
	}
        else {
           if (c == '"') in_quotes = TRUE;
           if ((c=='*') && (prev_c == '/')) in_comment = TRUE;
           *p++ = c;
	}
     }
     else {
        if ( ((c >= 'A') && (c <= 'Z')) || ((c >= 'a') && (c <= 'z'))
             || ((c >= '0') && (c <= '9')) || (c == '_') ) {
           id[++count] = c;
        }
        else {
           id[++count] = 0;
           strcpy(p,id);
           i = strlen(id);
           p += i;
           *p++ = c;
           in_identifier = FALSE;
	}
     }
     if (c == '\n') {
        if (buffer[0] == '#') {
           for(q=buffer+1;(*q == ' ') || (*q == '\t');q++);/*skip white space*/
           if (strncmp(q,"include",7) == 0) {
	      p = strchr(buffer,'\"');  /* forget about <...> */
	      if (p != NULL) {
	         q = strchr(p+1,'\"'); /* remove any comments */
	         q++;
	         *q++ = '\n';
	         *q++ = '\0';
	         if ((strchr(p,'/') != NULL)/* && (*(p+1) != '.')*/){ /* only fix "xx/yy" */
		    if (*(p+1) == '.') {
	               strcpy(newbuff,"#include \"[");
	               q = newbuff+11;
	            }
	            else {
	               strcpy(newbuff,"#include \"isode:[h.");
	               q = newbuff+19;
	            }
		    p++;
	            r = p;
	            while ( (p = strchr(p,'/')) != NULL) {
		       if (strncmp(r,"../",3) == 0) {
		          *q++ = '-';
		          *q++ = '.';
		       }
		       else if (strncmp(r,"./",2) == 0) {
		       }
		       else {
		          for(;r != p;) *q++ = *r++;
		          *q++ = '.';
	               }
		       p++;
		       r = p;
		    }
		    q--;       /*overwrite last . with a ]*/
		    if (*q == '[') q++; /* but not if of form "./xx"*/
		    *q++ = ']';
		    strcpy(q,r);
	            strcpy(buffer,newbuff);
	         }
	      }
	      p = strchr(buffer,'\"');
	      if (p != NULL) {
	         p++;
	         if (strncmp(p,"sys.file.h",10) == 0) *(p+3) = '_';
	         else if (strncmp(p,"sys.dirent.h",12) == 0) *(p+3) = '_';
	         else if (strncmp(p,"usr.dirent.h",12) == 0) *(p+3) = '_';
	         else if (strncmp(p,"stdio.h",7) == 0) {
	            *(p-1) = '<';
	            *(p+7) = '>';
	         }
	      }
	   }
        }
        fputs(buffer,outfile);
        memset(buffer,0,BUFFER);
	p = buffer;
     }
     prev_c = c;
     c = getc(infile);
  }
  fclose(infile);
  fclose(outfile);
  exit();
}

