$ set def isode:[imisc]
$ if p1 .EQS. "CLEAN" then goto clean
$ if p1 .EQS. "TIDY"  then goto tidy
$ debug == ""
$ if p1 .EQS. "DEBUG" then debug == p1
$ if f$trnlnm("isode_options") .NES. ""
$  then
$   options == "/define=(" + f$trnlnm("isode_options") + ",PEPYPATH)"
$  else
$   options == "/define=(PEPYPATH)"
$ endif
$ altered == 0
$ if f$search("isode_orig:[]imisc_tables.c") .NES. "" then goto m1
$ set def isode_orig:[]
$ rosy -m -pepsy -o IMISC-asn.py imisc.ry
$ pepsy "-A" -f -h -m IMISC-asn.py
$ set def isode:[]
$ m1:
$ @isode:[utils]h imisc-ops
$ @isode:[utils]h imisc-types
$ @isode:[utils]h ryinitiator
$ @isode:[utils]cc imisc
$ @isode:[utils]cc ryinitiator
$ if f$search("isode_orig:[]imisc-iops.c") .EQS. "" then $ copy isode_orig:[]imisc-ops.c isode_orig:[]imisc-iops.c
$ if f$trnlnm("isode_options") .NES. ""
$  then
$   options == "/define=(" + f$trnlnm("isode_options") + ",INVOKER,PEPYPATH)"
$  else
$   options == "/define=(INVOKER,PEPYPATH)"
$ endif
$ @isode:[utils]cc imisc-iops
$ if f$trnlnm("isode_options") .NES. ""
$  then
$   options == "/define=(" + f$trnlnm("isode_options") + ",PEPYPATH)"
$  else
$   options == "/define=(PEPYPATH)"
$ endif
$ @isode:[utils]cc imisc_tables
$ if f$search("imisc.exe") .EQS. "" then goto m4
$ if altered .EQ. 0 then $ write sys$output "imisc is up-to-date"
$ if altered .EQ. 0 then goto m6
$ delete imisc.exe;
$ m4:
$ write sys$output "Linking imisc"
$ dbg == ""
$ if debug .EQS. "DEBUG" then dbg = "/debug"
$ link/nomap 'dbg' imisc,ryinitiator,imisc-iops,imisc_tables, -
        [utils]psectopt/opt,[]opt/opt
$ copy imisc.exe bin:[000000]imisc.exe
$ pu bin:[000000]imisc.exe
$!
$ m6:
$ altered == 0
$ @isode:[utils]h ryresponder
$ @isode:[utils]cc imiscd
$ @isode:[utils]cc ryresponder
$ if f$search("isode_orig:[]imisc-rops.c") .EQS. "" then $ copy isode_orig:[]imisc-ops.c isode_orig:[]imisc-rops.c
$ if f$trnlnm("isode_options") .NES. ""
$  then
$   options == "/define=(" + f$trnlnm("isode_options") + ",PERFORMER,PEPYPATH)"
$  else
$   options == "/define=(PERFORMER,PEPYPATH)"
$ endif
$ @isode:[utils]cc imisc-rops
$ if f$trnlnm("isode_options") .NES. ""
$  then
$   options == "/define=(" + f$trnlnm("isode_options") + ",PEPYPATH)"
$  else
$   options == "/define=(PEPYPATH)"
$ endif
$ if f$search("imiscd.exe") .EQS. "" then goto m9
$ if altered .NE. 0 then goto m8
$ write sys$output "imiscd is up-to-date"
$ goto m10
$ m8:
$ delete imiscd.exe;
$ m9:
$ write sys$output "Linking imiscd"
$ link/nomap imiscd,ryresponder,imisc-rops,imisc_tables, -
        [utils]psectopt/opt,[]opt/opt
$ copy imiscd.exe etc:[000000]ros_imisc.exe
$ pu etc:[000000]ros_imisc.exe
$ m10:
$ @isode:[utils]cc imiscdlib
$ exit
$ tidy:
$ delete isode_orig:[]imisc-asn.py;*,imisc-ops.*;*,imisc-stubs.c;*
$ @isode:[utils]tidy
$ delete isode_orig:*_tables.*;*,*-types.h;*
$ exit
$ clean:
$ @isode:[utils]clean
$ delete isode_orig:*_tables.*;*,*-types.h;*,*.ph;*
$ delete isode_orig:[]imisc-asn.py;*,imisc-ops.*;*,imisc-stubs.c;*
$ exit

