$ set def isode:[pepsy]
$ if p1 .EQS. "CLEAN" then goto clean
$ if p1 .EQS. "TIDY"  then goto tidy
$ debug == ""
$ if p1 .EQS. "DEBUG" then debug == p1
$ if f$trnlnm("isode_options") .NES. ""
$  then
$   options == "/define=(" + f$trnlnm("isode_options") + ",PEPYPATH,PEPSYPATH="""""""""""")"
$  else
$   options == "/define=(PEPYPATH,PEPSYPATH="""""""""""")"
$ endif
$ map = "/nomap"
$ altered == 0
$!
$! lex.c is an exception to our rules - so handle differently
$ if f$search("lex.c") .EQS. "" then goto m2
$ orig_date = f$cvtime(f$file_attributes("lex.c_new","RDT"))
$ h_date   = f$cvtime(f$file_attributes("lex.c","RDT"))
$ if h_date .GTS. orig_date then goto m3
$ delete lex.c;
$ m2:
$ write sys$output "copy lex.c_new lex.c"
$ copy lex.c_new lex.c
$ altered == 1
$ m3:
$!
$ @isode:[utils]h pepsydefs
$ @isode:[utils]h pass2
$ @isode:[utils]h mine
$ @isode:[utils]h sym
$ @isode:[utils]cc pepsy
$ @isode:[utils]cc pepsy-yacc
$ @isode:[utils]cc pepsy_misc
$ @isode:[utils]cc pass2
$ @isode:[utils]cc etabs
$ @isode:[utils]cc dtabs
$ @isode:[utils]cc ptabs
$ @isode:[utils]cc dfns
$ @isode:[utils]cc mod
$ if f$search("pepsy.exe") .EQS. "" then goto m4
$ if altered .EQ. 0 then goto m5
$ delete pepsy.exe;
$ m4:
$ write sys$output "Linking pepsy"
$ link pepsy,pepsy-yacc,pepsy_misc,pass2,etabs,dtabs,ptabs,dfns,mod, -
         [utils]psectopt/opt,[]pepsyopt/opt
$!
$ m5:
$ if f$search("isode_orig:[]UNIV_tables.c") .NES. "" then goto m6
$ set def isode_orig:[]
$ pepsy "-A" -f -h -m UNIV.py
$ set def isode:[]
$ m6:
$ altered == 0
$ @isode:[utils]h univ-types
$ copy univ-types.h isode:[h]univ-types.h
$ pu isode:[h]
$ @isode:[utils]h pepsy-driver
$ @isode:[utils]cc univ_tables
$ @isode:[utils]cc enc
$ @isode:[utils]cc dec
$ @isode:[utils]cc fre
$ @isode:[utils]cc prnt
$ @isode:[utils]cc util
$ @isode:[utils]cc vprint
$! @isode:[utils]cc pepsy_str - put in compatlib!
$ @isode:[utils]cc py_advise
$ if f$search("pepsy_xfr.mar") .NES. "" then goto m0
$ write sys$output "Creating pepsy_xfr.mar - IGNORE any link errors!"
$ macro pepsy_xfr.dummy
$ delete collectopt.opt;
$ copy isode:[utils]collectopt.dummy collectopt.opt
$ if f$search("pepsylib.exe") .NES. "" then $ delete pepsylib.exe;*
$ map = "/map=pepsy.map/full"
$ set noon
$ gosub link
$ set on
$ map = "/nomap"
$ map_extract pepsy
$ delete pepsy.map;*
$ delete pepsy_xfr.obj;*
$ m0:
$ @isode:[utils]mar pepsy_xfr
$ if f$search("pepsylib.exe") .EQS. "" then goto m9
$ if altered .NE. 0 then goto m8
$ write sys$output "pepsylib is up-to-date"
$ goto m10
$ m8:
$ delete pepsylib.exe;
$ m9:
$ write sys$output "Linking pepsylib"
$ dbg == ""
$ if debug .EQS. "DEBUG" then dbg = "/debug"
$ gosub link
$ m10:
$ copy pepsy.exe bin:[000000]pepsy.exe
$ pu bin:[000000]pepsy.exe
$ exit
$ link:
$ link 'map' 'dbg'/share=pepsylib.exe -
	univ_tables,enc,dec,fre,prnt,util,vprint,py_advise, -
	[utils]psectopt/opt, -
        []collectopt/opt, -
	[]opt/opt
$ return
$ tidy:
$ @isode:[utils]tidy
$ exit
$ clean:
$ @isode:[utils]clean
$ exit

