$ set def isode:[pepy]
$ if p1 .EQS. "CLEAN" then goto clean
$ if p1 .EQS. "TIDY"  then goto tidy
$ debug == ""
$ if p1 .EQS. "DEBUG" then debug == p1
$ if f$trnlnm("isode_options") .NES. ""
$  then
$   options == "/define=(" + f$trnlnm("isode_options") + ",PEPYPATH="""""""""""")"
$  else
$   options == "/define=(PEPYPATH="""""""""""")"
$ endif
$ map = "/nomap"
$ altered == 0
$!
$! lex.c is an exception to our rules - so handle differently
$ if f$search("lex.c") .EQS. "" then goto m2
$ orig_date = f$cvtime(f$file_attributes("lex.c_new","RDT"))
$ h_date   = f$cvtime(f$file_attributes("lex.c","RDT"))
$ if h_date .GTS. orig_date then goto m3
$ delete lex.c;
$ m2:
$ write sys$output "copy lex.c_new lex.c"
$ copy lex.c_new lex.c
$ altered == 1
$ m3:
$!
$ @isode:[utils]h pepy
$ @isode:[utils]cc pepy
$ @isode:[utils]cc pepy_do
$ @isode:[utils]cc pepy_undo
$ @isode:[utils]cc yacc
$ @isode:[utils]cc pepy_misc
$ if f$search("pepy.exe") .EQS. "" then goto m4
$ if altered .EQ. 0 then $ write sys$output "pepy is up-to-date"
$ if altered .EQ. 0 then goto m5
$ delete pepy.exe;
$ m4:
$ write sys$output "Linking pepy"
$ link pepy,pepy_do,pepy_undo,pepy_misc,yacc, -
         [utils]psectopt/opt,[]pepyopt/opt
$ if f$search("posy.exe") .EQS. "" then goto m5
$ delete posy.exe;
$ m5:
$ altered == 0
$ @isode:[utils]cc posy
$ if f$search("posy.exe") .EQS. "" then goto m6
$ if altered .EQ. 0 then $ write sys$output "posy is up-to-date"
$ if altered .EQ. 0 then goto m7
$ delete posy.exe;
$ m6:
$ write sys$output "Linking posy"
$ link posy,pepy_misc,yacc, -
         [utils]psectopt/opt,[]pepyopt/opt
$!
$ m7:
$ altered == 0
$ if f$search("isode_orig:[]upepy-1.c") .NES. "" then goto m8
$ set def isode_orig:[]
$ pepy -a "PY_advise" -m "-A" -b UPEPY [-.pepsy]UNIV.py
$ posy -f -h -m -o UNIV-types.py [-.pepsy]UNIV.py
$ pepy -a "PY_advise" -m -b VPEPY UNIV-types.py
$ pepy -a "PY_advise" -m testdebug.py
$ pepy -a "PY_advise" -m  pepytest.py
$ pepy -a "PY_advise" -m  pp.py
$ set def isode:[]
$ m8:
$ @isode:[utils]h univ-types
$ @isode:[utils]cc upepy-1
$ @isode:[utils]cc upepy-2
$ @isode:[utils]cc upepy-3
$ @isode:[utils]cc upepy-4
$ @isode:[utils]cc upepy-5
$ @isode:[utils]cc upepy-6
$ @isode:[utils]cc upepy-7
$ @isode:[utils]cc upepy-8
$ @isode:[utils]cc upepy-9
$ @isode:[utils]cc upepy-10
$ @isode:[utils]cc upepy-11
$ @isode:[utils]cc upepy-12
$ @isode:[utils]cc upepy-13
$ @isode:[utils]cc upepy-14
$ @isode:[utils]cc upepy-15
$ @isode:[utils]cc upepy-16
$ @isode:[utils]cc upepy-17
$ @isode:[utils]cc upepy-18
$ @isode:[utils]cc upepy-19
$ @isode:[utils]cc upepy-20
$ @isode:[utils]cc upepy-21
$ @isode:[utils]cc upepy-22
$ @isode:[utils]cc upepy-23
$ @isode:[utils]cc upepy-24
$ @isode:[utils]cc upepy-25
$ @isode:[utils]cc upepy-26
$ @isode:[utils]cc upepy-27
$ @isode:[utils]cc upepy-28
$ @isode:[utils]cc upepy-29
$ @isode:[utils]cc upepy-30
$ @isode:[utils]cc upepy-31
$ @isode:[utils]cc upepy-32
$ @isode:[utils]cc upepy-33
$ @isode:[utils]cc upepy-34
$ @isode:[utils]cc upepy-35
$ @isode:[utils]cc upepy-36
$ @isode:[utils]cc upepy-37
$ @isode:[utils]cc upepy-38
$ @isode:[utils]cc upepy-39
$ @isode:[utils]cc upepy-40
$ @isode:[utils]cc upepy-41
$ @isode:[utils]cc upepy-42
$ @isode:[utils]cc upepy-43
$ @isode:[utils]cc upepy-44
$ @isode:[utils]cc upepy-45
$ @isode:[utils]cc upepy-46
$ @isode:[utils]cc upepy-47
$ @isode:[utils]cc upepy-48
$ @isode:[utils]cc upepy-49
$ @isode:[utils]cc upepy-50
$ @isode:[utils]cc upepy-51
$ @isode:[utils]cc upepy-52
$ @isode:[utils]cc vpepy-1
$ @isode:[utils]cc vpepy-2
$ @isode:[utils]cc vpepy-3
$ @isode:[utils]cc vpepy-4
$ @isode:[utils]cc vpepy-5
$ @isode:[utils]cc vpepy-6
$ @isode:[utils]cc vpepy-7
$ @isode:[utils]cc vpepy-8
$ @isode:[utils]cc vpepy-9
$ @isode:[utils]cc vpepy-10
$ @isode:[utils]cc vpepy-11
$ @isode:[utils]cc vpepy-12
$ @isode:[utils]cc vpepy-13
$ @isode:[utils]cc vpepy-14
$ @isode:[utils]cc vpepy-15
$ @isode:[utils]cc vpepy-16
$ @isode:[utils]cc vpepy-17
$ @isode:[utils]cc vpepy-18
$ @isode:[utils]cc vpepy-19
$ @isode:[utils]cc vpepy-20
$ @isode:[utils]cc vpepy-21
$ @isode:[utils]cc vpepy-22
$ @isode:[utils]cc vpepy-23
$ @isode:[utils]cc vpepy-24
$ @isode:[utils]cc vpepy-25
$ @isode:[utils]cc vpepy-26
$ @isode:[utils]cc vpepy-27
$ @isode:[utils]cc vpepy-28
$ @isode:[utils]cc vpepy-29
$ @isode:[utils]cc vpepy-30
$ @isode:[utils]cc vpepy-31
$ @isode:[utils]cc vpepy-32
$ @isode:[utils]cc vpepy-33
$ @isode:[utils]cc vpepy-34
$ @isode:[utils]cc vpepy-35
$ @isode:[utils]cc py_pp
$ @isode:[utils]cc testdebug
$ if f$search("pepy_xfr.mar") .NES. "" then goto m0
$ write sys$output "Creating pepy_xfr.mar - IGNORE any link errors!"
$ macro pepy_xfr.dummy
$ delete collectopt.opt;
$ copy isode:[utils]collectopt.dummy collectopt.opt
$ if f$search("pepylib.exe") .NES. "" then $ delete pepylib.exe;*
$ map = "/map=pepy.map/full"
$ set noon
$ gosub link
$ set on
$ map = "/nomap"
$ map_extract pepy
$ delete pepy.map;*
$ delete pepy_xfr.obj;*
$ m0:
$ @isode:[utils]mar pepy_xfr
$ if f$search("pepylib.exe") .EQS. "" then goto m10
$ if altered .NE. 0 then goto m9
$ write sys$output "pepylib is up-to-date"
$ goto m11
$ m9:
$ delete pepylib.exe;
$ m10:
$ write sys$output "Linking pepylib"
$ dbg == ""
$ if debug .EQS. "DEBUG" then dbg = "/debug"
$ gosub link
$ m11:
$ copy pepy.exe bin:[000000]pepy.exe
$ copy posy.exe bin:[000000]posy.exe
$ pu bin:[000000]pepy.exe
$ pu bin:[000000]posy.exe
$ exit
$ link:
$ link 'map' 'dbg'/share=pepylib.exe -
	upepy-1,upepy-2,upepy-3,upepy-4,upepy-5,upepy-6,upepy-7,upepy-8, -
	upepy-9,upepy-10,upepy-11,upepy-12,upepy-13,upepy-14,upepy-15,upepy-16, -
	upepy-17,upepy-18,upepy-19,upepy-20,upepy-21,upepy-22,upepy-23,upepy-24, -
	upepy-25,upepy-26,upepy-27,upepy-28,upepy-29,upepy-30,upepy-31,upepy-32, -
	upepy-33,upepy-34,upepy-35,upepy-36,upepy-37,upepy-38,upepy-39,upepy-40, -
	upepy-41,upepy-42,upepy-43,upepy-44,upepy-45,upepy-46,upepy-47,upepy-48, -
	upepy-49,upepy-50,upepy-51,upepy-52, -
	vpepy-1,vpepy-2,vpepy-3,vpepy-4,vpepy-5,vpepy-6,vpepy-7,vpepy-8, -
	vpepy-9,vpepy-10,vpepy-11,vpepy-12,vpepy-13,vpepy-14,vpepy-15,vpepy-16, -
	vpepy-17,vpepy-18,vpepy-19,vpepy-20,vpepy-21,vpepy-22,vpepy-23,vpepy-24, -
	vpepy-25,vpepy-26,vpepy-27,vpepy-28,vpepy-29,vpepy-30,vpepy-31,vpepy-32, -
	vpepy-33,vpepy-34,vpepy-35, -
	py_pp,testdebug, -
        [utils]psectopt/opt, -
        []collectopt/opt, -
	[]opt/opt
$ return
$ tidy:
$ @isode:[utils]tidy
$ delete isode_orig:[]upepy-*.c;*,vpepy-*.c;*,univ-types.*;*,univ.c;*
$ exit
$ clean:
$ @isode:[utils]clean
$ delete isode_orig:[]upepy-*.c;*,vpepy-*.c;*,univ-types.*;*,*.ph;*,univ.c;*
$ exit

