$ set def isode:[psap2]
$ if p1 .EQS. "CLEAN" then goto clean
$ if p1 .EQS. "TIDY"  then goto tidy
$ debug == ""
$ if p1 .EQS. "DEBUG" then debug == p1
$ if f$trnlnm("isode_options") .NES. ""
$  then
$   options == "/define=(" + f$trnlnm("isode_options") + ",PEPYPATH)"
$  else
$   options == "/define=(PEPYPATH)"
$ endif
$ map = "/nomap"
$ altered == 0
$ if f$search("isode_orig:[]ps_tables.c") .NES. "" then goto m1
$ set def isode_orig:[]
$ pepsy "-A" -f -h -m ps.py
$ set def isode:[]
$ m1:
$ @isode:[utils]h ps-types
$ @isode:[utils]cc ps_tables
$ @isode:[utils]cc psap2error
$ @isode:[utils]cc psapabort
$ @isode:[utils]cc psapactivity
$ @isode:[utils]cc psapexec
$ @isode:[utils]cc psapinitiate
$ @isode:[utils]cc psaplose
$ @isode:[utils]cc psapmajor1
$ @isode:[utils]cc psapmajor2
$ @isode:[utils]cc psapminor1
$ @isode:[utils]cc psapminor2
$ @isode:[utils]cc psaprelease1
$ @isode:[utils]cc psaprelease2
$ @isode:[utils]cc psapreport
$ @isode:[utils]cc psaprespond
$ @isode:[utils]cc psapresync1
$ @isode:[utils]cc psapresync2
$ @isode:[utils]cc psaprovider
$ @isode:[utils]cc psapselect
$ @isode:[utils]cc psaptoken
$ if f$search("psap2_xfr.mar") .NES. "" then goto m0
$ write sys$output "Creating psap2_xfr.mar - IGNORE any link errors!"
$ macro psap2_xfr.dummy
$ delete collectopt.opt;
$ copy isode:[utils]collectopt.dummy collectopt.opt
$ if f$search("psap2lib.exe") .NES. "" then $ delete psap2lib.exe;*
$ map = "/map=psap2.map/full"
$ set noon
$ gosub link
$ set on
$ map = "/nomap"
$ map_extract psap2
$ delete psap2.map;*
$ delete psap2_xfr.obj;*
$ m0:
$ @isode:[utils]mar psap2_xfr
$ if f$search("psap2lib.exe") .EQS. "" then goto m4
$ if altered .NE. 0 then goto m3
$ write sys$output "psap2lib is up-to-date"
$ exit
$ m3:
$ delete psap2lib.exe;
$ m4:
$ write sys$output "Linking psap2lib"
$ dbg == ""
$ if debug .EQS. "DEBUG" then dbg = "/debug"
$ gosub link
$ exit
$ link:
$ link 'map' 'dbg'/share=psap2lib.exe -
	ps_tables,psap2error,psapabort,psapactivity,psapexec, -
	psapinitiate,psaplose,psapmajor1,psapmajor2,psapminor1,psapminor2, -
	psaprelease1,psaprelease2,psapreport,psaprespond,psapresync1, -
	psapresync2,psaprovider,psapselect,psaptoken, -
        [utils]psectopt/opt, -
        []collectopt/opt, -
	[]opt/opt
$ return
$ tidy:
$ @isode:[utils]tidy
$ delete isode_orig:[]*_tables.*;*,*-types.h;*
$ exit
$ clean:
$ @isode:[utils]clean
$ delete isode_orig:[]*_tables.*;*,*-types.h;*,*.ph;*
$ exit

