$ set def isode:[quipu]
$ if p1 .EQS. "CLEAN" then goto clean
$ if p1 .EQS. "TIDY"  then goto tidy
$ debug == ""
$ if p1 .EQS. "DEBUG" then debug == p1
$ if f$trnlnm("isode_options") .NES. ""
$  then
$   options == "/define=(" + f$trnlnm("isode_options") + ",PEPYPATH)"
$  else
$   options == "/define=(PEPYPATH)"
$ endif
$ altered == 0
$ m1:
$ @isode:[utils]cc quipuvrsn
$ @isode:[utils]cc sys_init
$ @isode:[utils]cc sys_tai
$ @isode:[utils]cc tai_args
$ @isode:[utils]cc tai_init
$ @isode:[utils]cc control
$ @isode:[utils]cc acl_info
$ @isode:[utils]cc eis_select
$ @isode:[utils]cc parse2
$ @isode:[utils]cc schema
$ @isode:[utils]cc dsp_cache
$ @isode:[utils]cc malloc
$ @isode:[utils]cc entry_dump
$ @isode:[utils]cc entry_load
$ @isode:[utils]cc ds_read
$ @isode:[utils]cc ds_add
$ @isode:[utils]cc ds_compare
$ @isode:[utils]cc ds_modify
$ @isode:[utils]cc ds_modifyrdn
$ @isode:[utils]cc ds_list
$ @isode:[utils]cc ds_remove
$ @isode:[utils]cc ds_search
$ @isode:[utils]cc ds_abandon
$ @isode:[utils]cc ds_bind
$ @isode:[utils]cc get_dsa_info
$ @isode:[utils]cc update
$ @isode:[utils]cc find_entry
$ @isode:[utils]cc referral
$ @isode:[utils]cc ds_init
$ @isode:[utils]cc net_init
$ @isode:[utils]cc dsa
$ @isode:[utils]cc conn
$ @isode:[utils]cc task_act
$ @isode:[utils]cc oper_act
$ @isode:[utils]cc di_block
$ @isode:[utils]cc task_select
$ @isode:[utils]cc dsa_work
$ @isode:[utils]cc dsa_chain
$ @isode:[utils]cc dsa_wait
$ @isode:[utils]cc conn_disp
$ @isode:[utils]cc conn_init
$ @isode:[utils]cc conn_release
$ @isode:[utils]cc conn_request
$ @isode:[utils]cc conn_retry
$ @isode:[utils]cc conn_finish
$ @isode:[utils]cc conn_abort
$ @isode:[utils]cc task_invoke
$ @isode:[utils]cc task_result
$ @isode:[utils]cc task_error
$ @isode:[utils]cc task_ureject
$ @isode:[utils]cc oper_invoke
$ @isode:[utils]cc oper_result
$ @isode:[utils]cc oper_error
$ @isode:[utils]cc oper_preject
$ @isode:[utils]cc oper_ureject
$ @isode:[utils]cc pseudo
$ @isode:[utils]cc shadow
$ @isode:[utils]cc turbo_disk
$ @isode:[utils]cc turbo_debug
$ @isode:[utils]cc turbo_search
$ @isode:[utils]cc checkacl
$ if f$search("quipu.exe") .EQS. "" then goto m4
$ if altered .EQ. 0 then $ write sys$output "quipu is up-to-date"
$ if altered .EQ. 0 then goto m6
$ delete quipu.exe;
$ m4:
$ write sys$output "Linking quipu"
$ dbg == ""
$ if debug .EQS. "DEBUG" then dbg = "/debug"
$ link/nomap 'dbg' /exe=quipu.exe -
	quipuvrsn,sys_init,sys_tai,tai_args,tai_init,control, -
	acl_info,eis_select,parse2,schema, -
	dsp_cache,malloc,entry_dump,entry_load, -
	ds_read,ds_add,ds_compare,ds_modify,ds_modifyrdn, -
	ds_list,ds_remove,ds_search,ds_abandon,ds_bind, -
	get_dsa_info,update,find_entry,referral, -
	ds_init,net_init,dsa,conn,task_act,oper_act, -
	di_block,task_select,dsa_work,dsa_chain, -
	dsa_wait,conn_disp,conn_init,conn_release, -
	conn_request,conn_retry,conn_finish,conn_abort, -
	task_invoke,task_result,task_error,task_ureject, -
	oper_invoke,oper_result,oper_error,oper_preject, -
	oper_ureject,pseudo,shadow,turbo_disk,turbo_debug,turbo_search, -
	checkacl, -
        [utils]psectopt/opt,[]opt/opt
$!
$ m6:
$ exit
$ tidy:
$ @isode:[utils]tidy
$ exit
$ clean:
$ @isode:[utils]clean
$ exit

