$ c_file = p1+".c"
$ new_file = p1+".c_new"
$ orig_file = "isode_orig:"+c_file
$ obj_file = p1+".obj"
$ if f$search(new_file) .NES. "" then orig_file = new_file
$ orig_date = f$cvtime(f$file_attributes(orig_file,"RDT"))
$ if f$search(obj_file) .NES. ""
$  then
$   obj_date = f$cvtime(f$file_attributes(obj_file,"RDT"))
$   if obj_date .GTS. orig_date then exit
$   delete 'obj_file';
$ endif
$ if f$search(c_file) .EQS. "" then goto pp1
$ c_date   = f$cvtime(f$file_attributes(c_file,"RDT"))
$ if c_date .GTS. orig_date then goto cc0
$ delete 'c_file';
$ pp1:
$ write sys$output "preprocess ''orig_file' ''c_file' isode:[utils]long_names.dat"
$ gcc_cpp == "$ gnu_cc:[000000]gcc-cpp"
$ cpp_args = """-Iisode:[]"" ""-Iisode:[h]"" ""-P"""
$ if f$locate("/define",options) .NE. f$length(options)
$  then
$   inArg = f$extract(f$locate("=", options), f$length(options), options)
$   inArg = f$extract(2, f$length(inArg) - 3, inArg)
$   gosub parseList
$ endif
$ pass1 'orig_file' 'c_file'
$ sr = f$trnlnm("sockit_root")
$ gccinc = f$extract(0,f$length(sr)-1,sr) + "gccinclude.]"
$ if f$trnlnm("gnu_cc_include","lnm$process") .NES. ""
$  then
$   deass gnu_cc_include
$ endif
$ define/trans=conc gnu_cc_include 'gccinc'
$ gcc_cpp 'cpp_args' 'c_file' xxx.c
$ delete 'c_file';
$ pass2 xxx.c yyy.c isode:[utils]long_names.dat
$ delete xxx.c;*
$ trace yyy.c 'c_file'
$ delete yyy.c;*
$! pass2 xxx.c 'c_file' isode:[utils]long_names.dat
$! delete xxx.c;*
$
$ cc0:
$!
$ dbg == ""
$ if debug .EQS. "DEBUG" then dbg = "/debug/noopt"
$ write sys$output "gcc/include=(isode:[h])''options' ''dbg' ''c_file'"
$ gcc/nolist 'dbg' 'options' 'c_file'
$ if debug .NES. "DEBUG" then $ delete 'c_file';
$!
$ altered == 1
$ exit
$
$!
$!	Double up them double quotes
$!
$doubleQuotes:
$ k = f$length(arg)
$ if k .eq. 0 then goto noQuotes
$ j = 0
$ newArg = ""
$ dq1$:
$  c = f$extract(j,1,arg)
$  if c .eqs. """" then newArg = newArg + """"
$  newArg = newArg + c
$  j = j+1
$  if j .lt. k then goto dq1$
$ arg = newArg
$ noQuotes:
$ return
$!
$!	Parse a list of comma-separated tokens
$!
$!	inArg = input string
$!
$parseList:
$!echo = "write sys$output"
$ DQUOTE = """"
$ i = 0
$ len = f$length(inArg)
$ arg = ""
$ 1$:
$   if i .ge. len then goto noMoreDefines
$   c = f$extract(i, 1, inArg)
$   if c .eqs. DQUOTE then goto quotedString
$   if c .eqs. "," then goto OneDefineDone
$     arg = arg + c
$     goto 4$
$   quotedString:
$     arg = arg + c
$     i = i+1
$     2$:
$       if i .ge. len then goto noMoreDefines
$       c = f$extract(i, 1, inArg)
$       if c .nes. DQUOTE then goto 3$
$       if f$extract(i+1, 1, inArg) .eqs. DQUOTE then goto 2a$
$       arg = arg + c
$       goto 4$
$     2a$:
$       arg = arg + c
$       i = i+1
$     3$:
$       arg = arg + c
$	i = i+1
$    goto 2$
$    OneDefineDone:
$      gosub doubleQuotes
$!     echo "arg: ", arg
$      cpp_args = cpp_args + " ""-D" + arg + """
$      arg = ""
$      goto 4$
$    4$:
$      i = i+1
$      goto 1$
$ noMoreDefines:
$  if arg .eqs. "" then goto Defines_Done
$  gosub doubleQuotes
$! echo "arg: ", arg
$  cpp_args = cpp_args + " " + DQUOTE + "-D" + arg + DQUOTE
$!
$ Defines_Done:
$! echo "cpp_args: ", cpp_args
$  return

